package ink.wgink.code.factory.controller;

import com.sun.javafx.robot.impl.FXRobotHelper;
import ink.wgink.code.factory.utils.MsgUtil;
import javafx.application.Platform;
import javafx.concurrent.Service;
import javafx.concurrent.Task;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.PasswordField;
import javafx.scene.control.TextField;
import javafx.stage.Stage;
import lombok.SneakyThrows;
import org.apache.commons.lang3.StringUtils;

import java.io.IOException;

/**
 * When you feel like quitting. Think about why you started
 * 当你想要放弃的时候，想想当初你为何开始
 *
 * @ClassName: LoginController
 * @Description: 登录
 * @Author: WangGeng
 * @Date: 2021/3/2 21:25
 * @Version: 1.0
 **/
public class LoginController {

    public final static String DEFAULT_USERNAME = "admin";
    public final static String DEFAULT_PASSWORD = "aaa111!!!";
    @FXML
    private TextField usernameField;
    @FXML
    private PasswordField passwordField;
    private Stage primaryStage;

    @FXML
    public void onLoginClick(ActionEvent actionEvent) throws IOException {
        if (StringUtils.isBlank(usernameField.getText())) {
            MsgUtil.errorAlert("用户名不能为空");
            return;
        }
        if (StringUtils.isBlank(passwordField.getText())) {
            MsgUtil.errorAlert("密码不能为空");
            return;
        }
        if (!StringUtils.equalsIgnoreCase(DEFAULT_USERNAME, usernameField.getText())
                || !StringUtils.equals(DEFAULT_PASSWORD, passwordField.getText())) {
            MsgUtil.errorAlert("用户名或密码错误");
            return;
        }
        MsgUtil.loading(primaryStage);
        new Service<Integer>() {
            @Override
            protected Task<Integer> createTask() {
                return new Task<Integer>() {
                    @Override
                    protected Integer call() throws Exception {
                        Thread.sleep(1000);
                        Platform.runLater(new Runnable() {
                            @SneakyThrows
                            @Override
                            public void run() {
                                primaryStage.close();
                                MsgUtil.closeNewLoading();
                                FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("/route/main.fxml"));
                                final Stage stage = new Stage();
                                stage.setScene(new Scene(fxmlLoader.load()));
                                MainController mainController = fxmlLoader.getController();
                                mainController.setMainStage(stage);
                                stage.show();
                            }
                        });
                        return 0;
                    }
                };
            }
        }.start();

    }

    public void setPrimaryStage(Stage primaryStage) {
        this.primaryStage = primaryStage;
    }
}
