package ink.wgink.code.factory.factory;

import ink.wgink.code.factory.service.FieldService;
import ink.wgink.code.factory.vos.FieldVO;
import javafx.beans.property.ReadOnlyObjectWrapper;
import javafx.beans.value.ObservableValue;
import javafx.collections.ObservableList;
import javafx.concurrent.Service;
import javafx.concurrent.Task;
import javafx.scene.control.Button;
import javafx.scene.control.CheckBox;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.util.Callback;
import org.apache.commons.lang3.StringUtils;

import java.lang.reflect.Field;

/**
 * When you feel like quitting. Think about why you started
 * 当你想要放弃的时候，想想当初你为何开始
 *
 * @ClassName: ButtonTableCellFactory
 * @Description: 按钮表格
 * @Author: WangGeng
 * @Date: 2021/3/8 22:07
 * @Version: 1.0
 **/
public class ButtonTableCellFactory implements Callback<TableColumn.CellDataFeatures<FieldVO, String>, ObservableValue<Button>> {

    private String property;
    private FieldService fieldService;

    public ButtonTableCellFactory(String property, FieldService fieldService) {
        this.property = property;
        this.fieldService = fieldService;
    }

    @Override
    public ObservableValue<Button> call(TableColumn.CellDataFeatures<FieldVO, String> param) {
        Button button = new Button("删除");
        button.setOnAction(event -> {
            fieldService.removeField(param.getValue().getColumnName());
        });
        return new ReadOnlyObjectWrapper<>(button);
    }

}
