package ink.wgink.code.factory.factory;

import com.sun.deploy.uitoolkit.impl.fx.ui.FXUIFactory;
import ink.wgink.code.factory.vos.FieldVO;
import javafx.beans.property.ReadOnlyObjectWrapper;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.control.CheckBox;
import javafx.scene.control.TableColumn;
import javafx.util.Callback;
import org.apache.commons.lang3.StringUtils;

/**
 * When you feel like quitting. Think about why you started
 * 当你想要放弃的时候，想想当初你为何开始
 *
 * @ClassName: CheckboxTableCellFactory
 * @Description: 表格checkbox
 * @Author: WangGeng
 * @Date: 2021/3/6 18:46
 * @Version: 1.0
 **/
public class CheckBoxTableCellFactory implements Callback<TableColumn.CellDataFeatures<FieldVO, String>, ObservableValue<CheckBox>> {
    public static final String IS_FORM_SHOW = "isFormShow";
    public static final String IS_LIST_SHOW = "isListShow";
    public static final String IS_NOT_NULL = "isNotNull";
    public static final String IS_PRIMARY_KEY = "isPrimaryKey";
    private final String property;

    public CheckBoxTableCellFactory(String property) {
        this.property = property;
    }

    @Override
    public ObservableValue<CheckBox> call(TableColumn.CellDataFeatures<FieldVO, String> param) {
        FieldVO fieldVO = param.getValue();
        CheckBox checkBox = new CheckBox();
        if (StringUtils.equals(IS_FORM_SHOW, property)) {
            Boolean isFormShow = param.getValue().getFormShow();
            checkBox.setSelected(isFormShow == null || !isFormShow ? false : true);
        }
        if (StringUtils.equals(IS_LIST_SHOW, property)) {
            Boolean isListShow = param.getValue().getListShow();
            checkBox.setSelected(isListShow == null || !isListShow ? false : true);
        }
        if (StringUtils.equals(IS_NOT_NULL, property)) {
            Boolean isNotNull = param.getValue().getNotNull();
            checkBox.setSelected(isNotNull == null || !isNotNull ? false : true);
        }
        checkBox.selectedProperty().addListener((observable, oldValue, newValue) -> {
            if (StringUtils.equals(IS_FORM_SHOW, property)) {
                fieldVO.setFormShow(newValue);
            }
            if (StringUtils.equals(IS_LIST_SHOW, property)) {
                fieldVO.setListShow(newValue);
            }
            if (StringUtils.equals(IS_NOT_NULL, property)) {
                fieldVO.setNotNull(newValue);
            }
        });
        return new ReadOnlyObjectWrapper<>(checkBox);
    }
}
