package ink.wgink.code.factory.factory;

import ink.wgink.code.factory.vos.FieldVO;
import javafx.beans.property.ReadOnlyObjectWrapper;
import javafx.beans.value.ObservableValue;
import javafx.scene.control.RadioButton;
import javafx.scene.control.TableColumn;
import javafx.scene.control.ToggleGroup;
import javafx.util.Callback;

/**
 * When you feel like quitting. Think about why you started
 * 当你想要放弃的时候，想想当初你为何开始
 *
 * @ClassName: RadioBoxTableCellFactory
 * @Description: 单选框
 * @Author: WangGeng
 * @Date: 2021/3/8 21:17
 * @Version: 1.0
 **/
public class RadioButtonTableCellFactory implements Callback<TableColumn.CellDataFeatures<FieldVO, String>, ObservableValue<RadioButton>> {

    public static final String IS_PRIMARY_KEY = "isPrimaryKey";
    public static final String PRIMARY_KEY_SUFFIX = "_id";
    private static final ToggleGroup toggleGroup = new ToggleGroup();
    private final String property;

    public RadioButtonTableCellFactory(String property) {
        this.property = property;
    }

    @Override
    public ObservableValue<RadioButton> call(TableColumn.CellDataFeatures<FieldVO, String> param) {
        RadioButton radioButton = new RadioButton();
        radioButton.setToggleGroup(toggleGroup);
        if (param.getValue().getColumnName().endsWith(PRIMARY_KEY_SUFFIX)) {
            radioButton.selectedProperty().set(true);
        }
        return new ReadOnlyObjectWrapper<>(radioButton);
    }
}
