package ink.wgink.code.factory.vos;

import javafx.beans.property.SimpleIntegerProperty;
import javafx.beans.property.SimpleStringProperty;

/**
 * When you feel like quitting. Think about why you started
 * 当你想要放弃的时候，想想当初你为何开始
 *
 * @ClassName: FieldVO
 * @Description: 字段
 * @Author: WangGeng
 * @Date: 2021/3/6 17:35
 * @Version: 1.0
 **/
public class FieldVO {

    private SimpleIntegerProperty rowNumber;
    private SimpleStringProperty columnName;
    private SimpleStringProperty columnComment;
    private SimpleStringProperty columnDefault;
    private String dataType;
    private SimpleStringProperty columnType;
    private Integer characterMaximum;
    private Integer numericPrecision;
    private Integer numericScale;
    private SimpleStringProperty propertyName;
    private SimpleStringProperty propertyType;
    private SimpleIntegerProperty propertyLength;
    private String formFieldType;
    private String formFieldValue;
    private Boolean isFormShow;
    private Boolean isListShow;
    private Boolean isNotNull;

    public FieldVO() {
        this.rowNumber = new SimpleIntegerProperty(0);
        this.columnName = new SimpleStringProperty();
        this.columnComment = new SimpleStringProperty();
        this.columnDefault = new SimpleStringProperty();
        this.columnType = new SimpleStringProperty();
        this.propertyName = new SimpleStringProperty();
        this.propertyType = new SimpleStringProperty();
        this.propertyLength = new SimpleIntegerProperty(0);
    }

    public int getRowNumber() {
        return rowNumber.get();
    }

    public SimpleIntegerProperty rowNumberProperty() {
        return rowNumber;
    }

    public void setRowNumber(int rowNumber) {
        this.rowNumber.set(rowNumber);
    }

    public String getColumnName() {
        return columnName.get();
    }

    public SimpleStringProperty columnNameProperty() {
        return columnName;
    }

    public void setColumnName(String columnName) {
        this.columnName.set(columnName);
    }

    public String getColumnComment() {
        return columnComment.get();
    }

    public SimpleStringProperty columnCommentProperty() {
        return columnComment;
    }

    public void setColumnComment(String columnComment) {
        this.columnComment.set(columnComment);
    }

    public String getColumnDefault() {
        return columnDefault.get();
    }

    public SimpleStringProperty columnDefaultProperty() {
        return columnDefault;
    }

    public void setColumnDefault(String columnDefault) {
        this.columnDefault.set(columnDefault);
    }

    public String getDataType() {
        return dataType == null ? "" : dataType.trim();
    }

    public void setDataType(String dataType) {
        this.dataType = dataType;
    }

    public String getColumnType() {
        return columnType.get();
    }

    public SimpleStringProperty columnTypeProperty() {
        return columnType;
    }

    public void setColumnType(String columnType) {
        this.columnType.set(columnType);
    }

    public Integer getCharacterMaximum() {
        return characterMaximum;
    }

    public void setCharacterMaximum(Integer characterMaximum) {
        this.characterMaximum = characterMaximum;
    }

    public Integer getNumericPrecision() {
        return numericPrecision;
    }

    public void setNumericPrecision(Integer numericPrecision) {
        this.numericPrecision = numericPrecision;
    }

    public Integer getNumericScale() {
        return numericScale;
    }

    public void setNumericScale(Integer numericScale) {
        this.numericScale = numericScale;
    }

    public String getPropertyName() {
        return propertyName.get();
    }

    public SimpleStringProperty propertyNameProperty() {
        return propertyName;
    }

    public void setPropertyName(String propertyName) {
        this.propertyName.set(propertyName);
    }

    public String getPropertyType() {
        return propertyType.get();
    }

    public SimpleStringProperty propertyTypeProperty() {
        return propertyType;
    }

    public void setPropertyType(String propertyType) {
        this.propertyType.set(propertyType);
    }

    public int getPropertyLength() {
        return propertyLength.get();
    }

    public SimpleIntegerProperty propertyLengthProperty() {
        return propertyLength;
    }

    public void setPropertyLength(int propertyLength) {
        this.propertyLength.set(propertyLength);
    }

    public String getFormFieldType() {
        return formFieldType == null ? "" : formFieldType.trim();
    }

    public void setFormFieldType(String formFieldType) {
        this.formFieldType = formFieldType;
    }

    public String getFormFieldValue() {
        return formFieldValue == null ? "" : formFieldValue.trim();
    }

    public void setFormFieldValue(String formFieldValue) {
        this.formFieldValue = formFieldValue;
    }

    public Boolean getFormShow() {
        return isFormShow == null ? true : isFormShow;
    }

    public void setFormShow(Boolean formShow) {
        isFormShow = formShow;
    }

    public Boolean getListShow() {
        return isListShow == null ? true : isListShow;
    }

    public void setListShow(Boolean listShow) {
        isListShow = listShow;
    }

    public Boolean getNotNull() {
        return isNotNull == null ? false : isNotNull;
    }

    public void setNotNull(Boolean notNull) {
        isNotNull = notNull;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder("{");
        sb.append("\"rowNumber\":")
                .append(rowNumber);
        sb.append(",\"columnName\":")
                .append(columnName);
        sb.append(",\"columnComment\":")
                .append(columnComment);
        sb.append(",\"columnDefault\":")
                .append(columnDefault);
        sb.append(",\"dataType\":\"")
                .append(dataType).append('\"');
        sb.append(",\"columnType\":")
                .append(columnType);
        sb.append(",\"characterMaximum\":")
                .append(characterMaximum);
        sb.append(",\"numericPrecision\":")
                .append(numericPrecision);
        sb.append(",\"numericScale\":")
                .append(numericScale);
        sb.append(",\"propertyName\":")
                .append(propertyName);
        sb.append(",\"propertyType\":")
                .append(propertyType);
        sb.append(",\"propertyLength\":")
                .append(propertyLength);
        sb.append(",\"formFieldType\":\"")
                .append(formFieldType).append('\"');
        sb.append(",\"formFieldValue\":\"")
                .append(formFieldValue).append('\"');
        sb.append(",\"isFormShow\":")
                .append(isFormShow);
        sb.append(",\"isListShow\":")
                .append(isListShow);
        sb.append(",\"isNotNull\":")
                .append(isNotNull);
        sb.append('}');
        return sb.toString();
    }
}
