package ink.wgink.code.factory.vos;

import javafx.beans.property.SimpleIntegerProperty;
import javafx.beans.property.SimpleStringProperty;

/**
 * When you feel like quitting. Think about why you started
 * 当你想要放弃的时候，想想当初你为何开始
 *
 * @ClassName: TableVO
 * @Description:
 * @Author: WangGeng
 * @Date: 2021/3/3 14:07
 * @Version: 1.0
 **/
public class TableVO {

    private SimpleIntegerProperty rowNumber;
    private SimpleStringProperty tableName;
    private SimpleStringProperty tableCollation;
    private SimpleStringProperty tableComment;

    public TableVO() {
        this.rowNumber = new SimpleIntegerProperty();
        this.tableName = new SimpleStringProperty();
        this.tableCollation = new SimpleStringProperty();
        this.tableComment = new SimpleStringProperty();
    }

    public TableVO(Integer rowNumber, String tableName, String tableCollation, String tableComment) {
        this.rowNumber = new SimpleIntegerProperty(rowNumber);
        this.tableName = new SimpleStringProperty(tableName);
        this.tableCollation = new SimpleStringProperty(tableCollation);
        this.tableComment = new SimpleStringProperty(tableComment);
    }

    public int getRowNumber() {
        return rowNumber.get();
    }

    public SimpleIntegerProperty rowNumberProperty() {
        return rowNumber;
    }

    public void setRowNumber(int rowNumber) {
        this.rowNumber.set(rowNumber);
    }

    public String getTableName() {
        return tableName.get();
    }

    public SimpleStringProperty tableNameProperty() {
        return tableName;
    }

    public void setTableName(String tableName) {
        this.tableName.set(tableName);
    }

    public String getTableCollation() {
        return tableCollation.get();
    }

    public SimpleStringProperty tableCollationProperty() {
        return tableCollation;
    }

    public void setTableCollation(String tableCollation) {
        this.tableCollation.set(tableCollation);
    }

    public String getTableComment() {
        return tableComment.get();
    }

    public SimpleStringProperty tableCommentProperty() {
        return tableComment;
    }

    public void setTableComment(String tableComment) {
        this.tableComment.set(tableComment);
    }
}
