package ${codePackage}.pojo.vos.${lowerTableName};

import ink.wgink.annotation.CheckEmptyAnnotation;
import ink.wgink.annotation.CheckNumberAnnotation;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 *
 * @ClassName: ${firstUpperTableName}VO
 * @Description: ${tableExplain}
 * @Author: ${author}
 * @Date: ${date}
 * @Version: ${version}
 **/
@ApiModel
public class ${firstUpperTableName}VO {

<#list fieldList! as field>
    <#if field.formShow>
    @ApiModelProperty(name = "${field.propertyName}", value = "${field.columnComment}")
        <#if field.formFieldValue == "number">
    @CheckNumberAnnotation(name = "${field.columnComment}")
    private Integer ${field.propertyName};
        <#elseif field.formFieldValue == "double">
    @CheckNumberAnnotation(name = "${field.columnComment}")
    private Double ${field.propertyName};
        <#elseif field.formFieldValue == "date">
    @CheckEmptyAnnotation(name = "${field.columnComment}", verifyType = "date")
    private String ${field.propertyName};
        <#elseif field.formFieldValue == "datetime">
    @CheckEmptyAnnotation(name = "${field.columnComment}", verifyType = "datetime")
    private String ${field.propertyName};
        <#else>
            <#if field.formFieldValue == "string">
                <#if field.verifyType?? && field.verifyType != "none">
                    <#if field.verifyType == "phone">
    @CheckEmptyAnnotation(name = "${field.columnComment}", verifyType = "phone")
                    <#elseif field.verifyType == "email">
    @CheckEmptyAnnotation(name = "${field.columnComment}", verifyType = "email")
                    <#elseif field.verifyType == "url">
    @CheckEmptyAnnotation(name = "${field.columnComment}", verifyType = "url")
                    <#elseif field.verifyType == "number">
    @CheckEmptyAnnotation(name = "${field.columnComment}", verifyType = "number")
                    <#elseif field.verifyType == "date">
    @CheckEmptyAnnotation(name = "${field.columnComment}", verifyType = "date")
                    <#elseif field.verifyType == "identity">
    @CheckEmptyAnnotation(name = "${field.columnComment}", verifyType = "identity")
                    <#elseif field.verifyType == "custom">
    @CheckEmptyAnnotation(name = "${field.columnComment}", verifyType = "custom", regex = "${field.verifyType}")
                    <#elseif field.verifyType == "required">
    @CheckEmptyAnnotation(name = "${field.columnComment}")
                    </#if>
                </#if>
            </#if>
    private String ${field.propertyName};
        </#if>
    </#if>
</#list>

<#list fieldList! as field>
    <#if field.formShow>
        <#if field.formFieldValue == "number">
    public Integer get${field.firstUpperPropertyName}() {
        return ${field.propertyName} == null ? 0 : ${field.propertyName};
    }

    public void set${field.firstUpperPropertyName}(Integer ${field.propertyName}) {
        this.${field.propertyName} = ${field.propertyName};
    }

        <#elseif field.formFieldValue == "double">
    public Double get${field.firstUpperPropertyName}() {
        return ${field.propertyName} == null ? 0D : ${field.propertyName};
    }

    public void set${field.firstUpperPropertyName}(Double ${field.propertyName}) {
        this.${field.propertyName} = ${field.propertyName};
    }

        <#elseif field.formFieldValue == "date" || field.formFieldValue == "datetime">
    public String get${field.firstUpperPropertyName}() {
        return ${field.propertyName} == null ? "" : ${field.propertyName}.trim();
    }

    public void set${field.firstUpperPropertyName}(String ${field.propertyName}) {
        this.${field.propertyName} = ${field.propertyName};
    }

        <#else>
    public String get${field.firstUpperPropertyName}() {
        return ${field.propertyName} == null ? "" : ${field.propertyName}.trim();
    }

    public void set${field.firstUpperPropertyName}(String ${field.propertyName}) {
        this.${field.propertyName} = ${field.propertyName};
    }

        </#if>
    </#if>
</#list>

}
