package ${codePackage}.service.${lowerTableName}.impl;

import ink.wgink.common.base.DefaultBaseService;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResult;
import ink.wgink.pojo.result.SuccessResultList;
import ink.wgink.util.map.HashMapUtil;
import ink.wgink.util.UUIDUtil;
import ${codePackage}.dao.${lowerTableName}.I${firstUpperTableName}Dao;
import ${codePackage}.pojo.dtos.${lowerTableName}.${firstUpperTableName}DTO;
import ${codePackage}.pojo.vos.${lowerTableName}.${firstUpperTableName}VO;
import ${codePackage}.pojo.bos.${lowerTableName}.${firstUpperTableName}BO;
import ${codePackage}.pojo.pos.${lowerTableName}.${firstUpperTableName}PO;
import ${codePackage}.service.${lowerTableName}.I${firstUpperTableName}Service;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * @ClassName: ${firstUpperTableName}ServiceImpl
 * @Description: ${tableExplain}
 * @Author: ${author}
 * @Date: ${date}
 * @Version: ${version}
 **/
@Service
public class ${firstUpperTableName}ServiceImpl extends DefaultBaseService implements I${firstUpperTableName}Service {

    @Autowired
    private I${firstUpperTableName}Dao ${firstLowerTableName}Dao;

    @Override
    public void save(${firstUpperTableName}VO ${firstLowerTableName}VO) {
        saveReturnId(${firstLowerTableName}VO);
    }

    @Override
    public void save(String token, ${firstUpperTableName}VO ${firstLowerTableName}VO) {
        saveReturnId(token, ${firstLowerTableName}VO);
    }

    @Override
    public String saveReturnId(${firstUpperTableName}VO ${firstLowerTableName}VO) {
        return saveReturnId(null, ${firstLowerTableName}VO);
    }

    @Override
    public String saveReturnId(String token, ${firstUpperTableName}VO ${firstLowerTableName}VO) {
        String ${firstLowerTableName}Id = UUIDUtil.getUUID();
        Map<String, Object> params = HashMapUtil.beanToMap(${firstLowerTableName}VO);
        params.put("${firstLowerTableName}Id", ${firstLowerTableName}Id);
        if (StringUtils.isBlank(token)) {
            setSaveInfo(params);
        } else {
            setAppSaveInfo(token, params);
        }
        ${firstLowerTableName}Dao.save(params);
        return ${firstLowerTableName}Id;
    }

    @Override
    public void remove(List<String> ids) {
        remove(null, ids);
    }

    @Override
    public void remove(String token, List<String> ids) {
        Map<String, Object> params = getHashMap(2);
        params.put("${firstLowerTableName}Ids", ids);
        if (StringUtils.isBlank(token)) {
            setUpdateInfo(params);
        } else {
            setAppUpdateInfo(token, params);
        }
        ${firstLowerTableName}Dao.remove(params);
    }

    @Override
    public void delete(List<String> ids) {
        Map<String, Object> params = getHashMap(2);
        params.put("${firstLowerTableName}Ids", ids);
        ${firstLowerTableName}Dao.delete(params);
    }

    @Override
    public void update(String ${firstLowerTableName}Id, ${firstUpperTableName}VO ${firstLowerTableName}VO) {
        update(null, ${firstLowerTableName}Id, ${firstLowerTableName}VO);
    }

    @Override
    public void update(String token, String ${firstLowerTableName}Id, ${firstUpperTableName}VO ${firstLowerTableName}VO) {
        Map<String, Object> params = HashMapUtil.beanToMap(${firstLowerTableName}VO);
        params.put("${firstLowerTableName}Id", ${firstLowerTableName}Id);
        if (StringUtils.isBlank(token)) {
            setUpdateInfo(params);
        } else {
            setAppUpdateInfo(token, params);
        }
        ${firstLowerTableName}Dao.update(params);
    }

    @Override
    public ${firstUpperTableName}DTO get(Map<String, Object> params) {
        return ${firstLowerTableName}Dao.get(params);
    }

    @Override
    public ${firstUpperTableName}DTO get(String ${firstLowerTableName}Id) {
        Map<String, Object> params = super.getHashMap(2);
        params.put("${firstLowerTableName}Id", ${firstLowerTableName}Id);
        return get(params);
    }

    @Override
    public ${firstUpperTableName}BO getBO(Map<String, Object> params) {
        return ${firstLowerTableName}Dao.getBO(params);
    }

    @Override
    public ${firstUpperTableName}BO getBO(String ${firstLowerTableName}Id) {
        Map<String, Object> params = super.getHashMap(2);
        params.put("${firstLowerTableName}Id", ${firstLowerTableName}Id);
        return getBO(params);
    }

    @Override
    public ${firstUpperTableName}PO getPO(Map<String, Object> params) {
        return ${firstLowerTableName}Dao.getPO(params);
    }

    @Override
    public ${firstUpperTableName}PO getPO(String ${firstLowerTableName}Id) {
        Map<String, Object> params = super.getHashMap(2);
        params.put("${firstLowerTableName}Id", ${firstLowerTableName}Id);
        return getPO(params);
    }

    @Override
    public List<${firstUpperTableName}DTO> list(Map<String, Object> params) {
        return ${firstLowerTableName}Dao.list(params);
    }

    @Override
    public List<${firstUpperTableName}BO> listBO(Map<String, Object> params) {
        return ${firstLowerTableName}Dao.listBO(params);
    }

    @Override
    public List<${firstUpperTableName}PO> listPO(Map<String, Object> params) {
        return ${firstLowerTableName}Dao.listPO(params);
    }

    @Override
    public SuccessResultList<List<${firstUpperTableName}DTO>> listPage(ListPage page) {
        PageHelper.startPage(page.getPage(), page.getRows());
        List<${firstUpperTableName}DTO> ${firstLowerTableName}DTOs = list(page.getParams());
        PageInfo<${firstUpperTableName}DTO> pageInfo = new PageInfo<>(${firstLowerTableName}DTOs);
        return new SuccessResultList<>(${firstLowerTableName}DTOs, pageInfo.getPageNum(), pageInfo.getTotal());
    }

    @Override
    public Integer count(Map<String, Object> params) {
        Integer count = ${firstLowerTableName}Dao.count(params);
        return count == null ? 0 : count;
    }

}